#ifndef _BusyNode_h_
#define _BusyNode_h_

/* BusyNode.h created by benhur on Fri 27-Feb-1998 */

#include <AppKit/AppKit.h>
#include "BusyArray.h"
#include "ReduceEntityType.h"
#include "../General.bproj/MiscTree.h"
#include "../General.bproj/PajeFilter.h"

@interface BusyNode : PajeFilter
{
    IBOutlet NSBox *view;           // NSBox that contains interface objects
    IBOutlet NSTextField *entityNameField; // name of new entity type
    IBOutlet NSButton *createEntityButton;
    IBOutlet NSButton *renameEntityButton;
    IBOutlet NSButton *deleteEntityButton;
    IBOutlet NSPopUpButton *entityNamePopUp; // name of new entity type
    IBOutlet NSPopUpButton *entityTypePopUp; // select entity type to count
    IBOutlet NSPopUpButton *groupByPopUp; // select grouping
    IBOutlet NSPopUpButton *reduceModePopUp; // select way to reduce
    IBOutlet NSMatrix *nameMatrix; // switches; select event names to count
    MiscTree *hierarchyTree;
    NSMutableDictionary *entityTypesDictionary;
    NSMutableSet *reduceEntityTypes;
}

- (id)initWithController:(PajeTraceController *)c;
- (void)dealloc;


//
// default read and write
//
- (void)readDefaults;
- (void)registerDefaults;

//
// update interface
//
- (void)calcEntityTypes;
- (void)calcEntityNamePopUp;
- (void)calcEntityTypePopUp;
- (void)calcGroupPopUp;
- (void)calcReduceModePopUp;
- (void)refreshMatrix;

//
// interaction with interface
//
- (IBAction)createEntityType:(id)sender;
- (IBAction)deleteEntityType:(id)sender;
- (IBAction)renameEntityType:(id)sender;
- (IBAction)entityNamePopUpChanged:(id)sender;
- (IBAction)entityTypePopUpChanged:(id)sender;
- (IBAction)groupByPopUpChanged:(id)sender;
- (IBAction)reduceModePopUpChanged:(id)sender;
- (IBAction)matrixChanged:(id)sender;


//
- (void)calcHierarchyTree;
- (void)addToHierarchy:(ReduceEntityType *)entityType;

//
// filtering
//
- (NSEnumerator *)enumeratorOfEntitiesTyped:(PajeEntityType *)entityType
                                inContainer:(PajeContainer *)container
                                   fromTime:(NSDate *)start
                                     toTime:(NSDate *)end;

@end

#endif
