#ifndef _ReduceEntityType_h_
#define _ReduceEntityType_h_

#include "../General.bproj/PajeFilter.h"
#include "../General.bproj/PajeType.h"
#include "BusyArray.h"

@interface ReduceEntityType : PajeEntityType
{
    PajeFilter *component;
    Class entityClass;
    PajeEntityType *entityTypeToReduce;
    NSMutableSet *filterNames;       // entity names that are counted
    BusyArray *array;
    NSNumber *minValue;
    NSNumber *maxValue;
}

+ (ReduceEntityType *)typeWithName:(NSString *)n
                     containerType:(PajeContainerType *)cont
                         component:(PajeFilter *)comp;
+ (ReduceEntityType *)typeFromDictionary:(NSDictionary *)dict
                               component:(PajeFilter *)comp;
- (id)initWithName:(NSString *)n
     containerType:(PajeContainerType *)cont
         component:(PajeFilter *)comp;

- (NSDictionary *)dictionaryForDefaults;
- (PajeFilter *)component;

- (void)setName:(NSString *)n;

- (void)setContainerType:(PajeContainerType *)newContainerType;

- (void)setEntityClass:(Class)c;
- (Class)entityClass;

- (void)setEntityTypeToReduce:(PajeEntityType *)newEntityTypeToReduce;
- (PajeEntityType *)entityTypeToReduce;

- (void)addNameToFilter:(NSString *)n;
- (void)addNamesToFilter:(NSArray *)n;
- (void)removeNameFromFilter:(NSString *)n;
- (NSSet *)filterNames;

- (NSNumber *)minValue;
- (NSNumber *)maxValue;

- (NSEnumerator *)enumeratorOfEntitiesInContainer:(PajeContainer *)container
                                         fromTime:(NSDate *)start
                                           toTime:(NSDate *)end;
@end

#endif
