#ifndef _ContainerSelector_h_
#define _ContainerSelector_h_

/* ContainerSelector.h created by benhur on 13-feb-2001 */

#include <AppKit/AppKit.h>
#include "../General.bproj/FilteredEnumerator.h"
#include "../General.bproj/Protocols.h"
#include "../General.bproj/PajeFilter.h"
#include "../General.bproj/HierarchyBrowser.h"

@interface ContainerSelector : PajeFilter
{
    NSMutableDictionary *filters;
    IBOutlet id view;
    IBOutlet NSView *browserBox;
    HierarchyBrowser *hierarchyBrowser;
}

- (id)initWithController:(PajeTraceController *)c;
- (void)dealloc;

- (void)setFilterForEntityType:(PajeEntityType *)entityType;

// read and write defaults
- (NSMutableSet *)defaultFilterForEntityType:(PajeEntityType *)entityType;
- (void)registerDefaultFilter:(NSSet *)filter
                forEntityType:(PajeEntityType *)entityType;


- (PajeEntityType *)selectedEntityType;

//
// Handle interface messages
//
- (void)selectAll:(id)sender;
- (void)unselectAll:(id)sender;
- (void)matrixChanged:(id)sender;

//
// interact with interface
//
- (void)viewWillBeSelected:(NSView *)view;
- (void)synchronizeMatrix;


//
// methods in Trace for making the filtering
//
- (NSEnumerator *)enumeratorOfEntitiesTyped:(PajeEntityType *)entityType
                                inContainer:(PajeContainer *)container
                                   fromTime:(NSDate *)start
                                     toTime:(NSDate *)end;

//
// methods to be a dragging destination, as delegate of matrix
// (colors dropped in a cell change the color of the 
// entity type it represents)
//
- (unsigned int)matrix:(NSMatrix *)m draggingUpdated:(id <NSDraggingInfo>)sender;
- (BOOL)matrix:(NSMatrix *)m performDragOperation:(id <NSDraggingInfo>)sender;
- (void)matrix:(NSMatrix *)m draggingExited:(id <NSDraggingInfo>)sender;
// help method for highlighting the destination cell
- (void)highlightCell:(id)cell inMatrix:(NSMatrix *)m;

@end

#endif
