#ifndef _Encapsulate_h_
#define _Encapsulate_h_

//

#include <Foundation/Foundation.h>
#include "../General.bproj/PajeFilter.h"
#include "../General.bproj/Protocols.h"

@interface Encapsulate : PajeFilter
{
    BOOL                 traceChanged;
    BOOL                 timerActive;

    NSDate              *startTime;
    NSDate              *endTime;
    NSDate              *startTimeInMemory;
    NSDate              *endTimeInMemory;

    NSMutableDictionary *entityLists;   // dictionary (by entity type) of
                                        // dictionaries (by container) of
                                        // TimeList's of entities

    NSMutableDictionary *entityTypeToClass;

    MiscTree            *hierarchyTree;
    id                   rootInstance;
}

- (id)initWithController:(PajeTraceController *)c;

- (void)send;
- (void)timeElapsed:(id)sender;

- (void)addEntity:(id<PajeEntity>)entity;
- (void)_addToHierarchyTree:(id)entity;

- (void)removeObjectsBeforeTime:(NSDate *)time;
- (NSDate *)startTimeInMemory;

@end

#endif
