#ifndef _HierarchyBrowser_h_
#define _HierarchyBrowser_h_

#include <AppKit/AppKit.h>
#include "PajeFilter.h"

@interface HierarchyBrowser : NSObject
{
    PajeFilter *filter;
    IBOutlet NSBrowser *containerTypesBrowser;
    IBOutlet NSBrowser *containersBrowser;
    IBOutlet NSSplitView *splitView;
    BOOL containersOnly;
}

- (id)initWithFilter:(PajeFilter *)f;

- (NSView *)view;

- (void)setFilter:(PajeFilter *)f;

- (void)setContainersOnly:(BOOL)flag;

- (PajeEntityType *)selectedEntityType;
- (NSArray *)selectedContainers;
- (NSArray *)selectedNames;
- (PajeContainer *)selectedParentContainer;

- (void)refreshLastColumn;

// NSBrowser actions

- (IBAction)containerTypeSelected:(NSBrowser *)sender;
- (IBAction)containerSelected:(NSBrowser *)sender;


// NSBrowser  delegate

- (void)browser:(NSBrowser *)sender createRowsForColumn:(int)column inMatrix:(NSMatrix *)matrix;
- (void)containerTypesBrowser:(NSBrowser *)sender createRowsForColumn:(int)column inMatrix:(NSMatrix *)matrix;
- (void)containersBrowser:(NSBrowser *)sender createRowsForColumn:(int)column inMatrix:(NSMatrix *)matrix;

@end

#endif
