#ifndef _PSortedArray_h_
#define _PSortedArray_h_

/* PSortedArray.h created by benhur on Mon 07-Apr-1997 */

#include <Foundation/Foundation.h>
#include "Comparing.h"

@interface PSortedArray : NSObject//NSMutableArray
{
    NSMutableArray *array;
    SEL valueSelector;
}

+ (PSortedArray *)sortedArrayWithSelector:(SEL)sel;
- (id)initWithSelector:(SEL)sel;
- (unsigned)count;
- (id)objectAtIndex:(unsigned)index;
- (void)removeObjectAtIndex:(unsigned)index;
- (void)removeObject:(id)obj;
- (void)removeObjectIdenticalTo:(id)obj;
- (void)addObject:(id)obj;
- (void)verifyPositionOfObjectIdenticalTo:(id)obj;
- (NSEnumerator *)objectEnumerator;
- (NSEnumerator *)objectEnumeratorAfterValue:(id<Comparing>)value;
- (unsigned)indexOfFirstObjectNotBeforeValue:(id<Comparing>)value;
- (unsigned)indexOfLastObjectNotAfterValue:(id<Comparing>)value;
- (unsigned)indexOfObjectWithValue:(id<Comparing>)value;
- (unsigned)indexOfObject:(id)obj;
- (void)removeObjectsBeforeValue:(id<Comparing>)value;

// NSCoding Protocol
- (void)encodeWithCoder:(NSCoder *)coder;
- (id)initWithCoder:(NSCoder *)coder;
@end

#endif
