#ifndef _PTime_h_
#define _PTime_h_

/* PTime.h
 *
 * A subclass of NSDate that shows times as seconds.
 */

#include <Foundation/Foundation.h>

@interface PTime : NSDate<NSCoding>
{
    NSTimeInterval secondsSinceReferenceDate;
}

+ (void)setInitialTime:(PTime *)time;
- (id)initWithTimeIntervalSinceReferenceDate:(NSTimeInterval)seconds;

- (NSTimeInterval)timeIntervalSinceReferenceDate;

- (NSString *)description;

// NSCoding protocol
- (void)encodeWithCoder:(NSCoder *)coder;
- (id)initWithCoder:(NSCoder *)coder;
@end

#endif
