#ifndef _PajeEntityInspector_h_
#define _PajeEntityInspector_h_

#include <AppKit/AppKit.h>
#include "PajeEntity.h"
#include "PajeContainer.h"

@interface PajeEntityInspector : NSObject
{
    PajeEntity *inspectedEntity;
    NSWindow *inspectionWindow;
    NSTextField *nameField;
    NSColorWell *colorField;
    NSButton *reuseButton;
    NSButton *filterButton;
    NSBox *fieldBox;
    NSBox *relatedEntitiesBox;
    NSMatrix *relatedEntitiesMatrix;
    
    NSBox *fileBox;
    NSTextField *filenameField;
    NSTextField *lineNumberField;

    NSMutableSet *nonDisplayedFields;

    float top;
    float bottom;
}

- (id)init;
- (void)dealloc;

- (void)addSubview:(NSView *)view atBottom:(BOOL)atBottom;
- (void)addLastSubview:(NSView *)view;
- (NSBox *)boxWithTitle:(NSString *)boxTitle
            fieldTitles:(NSArray *)titles
            fieldValues:(NSArray *)values;
- (NSBox *)boxWithTitle:(NSString *)boxTitle
            fieldTitles:(NSArray *)titles
             fieldNames:(NSArray *)names;
- (void)addLocalFields;
- (void)addBoxForContainer:(PajeContainer *)container
             upToContainer:(PajeContainer *)upto
                 withTitle:(NSString *)title;

- (BOOL)isReusable;
- (void)setReusable:(BOOL)reuse;

- (void)inspect:(PajeEntity *)anObj;

- (IBAction)showSource:(id)sender;
- (IBAction)filterEntityName:(id)sender;
@end

#endif
