#ifndef _SourceCodeReference_h_
#define _SourceCodeReference_h_

//
// SourceCodeReference
//
// Contains a reference to a source line in a file.
//

#include <Foundation/Foundation.h>

@interface SourceCodeReference : NSObject
{
    NSString *filename;
    int lineNumber;
}

+ (SourceCodeReference *)referenceToFilename:(NSString *)name
                                  lineNumber:(int)line;
- (id)initWithFilename:(NSString *)name
            lineNumber:(int)line;

//
// accessors
//

- (NSString *)filename;
- (int)lineNumber;

//
// it can be hashed (NSObject protocol)
//
- (unsigned)hash;
- (BOOL)isEqual:(id)object;

@end

#endif
