//
// SourceTextController
//
// Shows a source file; can select lines and highlights events
// caused by a line when it is selected.
// controller and delegate of the textView that shows the source file
//

#import <AppKit/AppKit.h>

@interface SourceTextController : NSObject
{
    IBOutlet NSTextView *textView;
    NSString *filename;
}

+ (SourceTextController *)controllerForFilename:(NSString *)name;
- (id)initWithFilename:(NSString*)name;

- (void)selectLineNumber:(unsigned)lineNumber;

// This delegate method is called when the selection is about to change
// (and whenever the textView is clicked on).
- (NSRange)textView:(NSTextView *)aTextView
willChangeSelectionFromCharacterRange:(NSRange)oldRange
   toCharacterRange:(NSRange)newRange;

@end

