#ifndef _TimeList_h_
#define _TimeList_h_

// 

#include <Foundation/Foundation.h>
#include "PSortedArray.h"
#include "Protocols.h"

@interface TimeList: NSMutableDictionary
{
    NSMutableDictionary *intervalMap; // contains one array for each TIMEINTERVAL
                                      // (depending on -firstTime). Each array
                                      // is ordered by -lastTime.
    NSNumber *firstKey;               // smallest key in map
}

+ timeList;
- init;

- (unsigned)count;
- (id)objectForKey:(id)key;
- (NSEnumerator *)timeEnumeratorFromTime:(NSDate *)start
                                  toTime:(NSDate *)end;
- (void)addObject:(id <PajeTiming>)anObject;
- (void)objectChangedEndTime:(id <PajeTiming>)anObject;
- (id)firstKey;

- (void)removeObjectsBeforeTime:(NSDate *)time;
- (void)removeObjectsAfterTime:(NSDate *)time;
@end

#endif
