#ifndef _TranslationTable_h_
#define _TranslationTable_h_

// TranslationTable
//
// has elements of type <index, value>, both integers.
// index is sequential, starting at 0. it's the order of insertion
//       in the table.
// value is any number.
// has methods to return a value, given an index (like an array)
// and to return the index of a given value.

#include <Foundation/Foundation.h>
#include <AppKit/AppKit.h>

@interface TranslationTable: NSObject
{
    NSMutableArray    *table;    // to map from indexes to values
    NSMutableDictionary        *map;    // to map from values to indexes
    // change to NSMapTable when it exists.
}

// Initializing
+ (TranslationTable *)translationTable;
- (id)init;

// Querying
- (unsigned)count;
- (unsigned)indexOfValue:(id)value;
- (id)valueAtIndex:(unsigned)index;

// Adding Elements
- (unsigned)addValue:(id)value;    // returns index of element
                                    // doesn't insert if already exists

// NSCoding Protocol
- (void)encodeWithCoder:(NSCoder *)coder;
- (id)initWithCoder:(NSCoder *)coder;
@end

#endif
