#ifndef _UniqueString_h_
#define _UniqueString_h_

// UniqueString.h
//
// Strings of this class are uniqued, all equal instances are the same object.
//

#include <Foundation/NSObject.h>

#define U(s) [UniqueString stringWithString:s]

@interface UniqueString : NSObject
{
    NSObject *string;
}

+ (UniqueString *)stringWithString:(NSString *)s;

// primitive methods
//- (unsigned int)length;			
//- (unichar)characterAtIndex:(unsigned)index;

// NSObject protocol
- (BOOL)isEqual:(id)object;
- (unsigned)hash;
@end

#endif
