#ifndef _ProcRuler_h_
#define _ProcRuler_h_
#include <AppKit/AppKit.h>
#include "DrawView.h"

typedef enum {
    procRulerNone, 
    procRulerVerticalDivider, 
    procRulerHorizontalDivider, 
    procRulerBox 
} procRulerPart;

@interface ProcRuler : NSRulerView
{
    NSMutableArray *thicknesses;
    NSCell *cell;
}

- (id)initWithScrollView:(NSScrollView *)scrollView;
- (void)drawHashMarksAndLabelsInRect:(NSRect)drawRect;
- (void)refreshSizes;
- (void)drawTree:(MiscTree *)tree
          inRect:(NSRect)drawRect
           level:(int)level
          offset:(float)offset;
- (void)drawInstancesOfDescriptor:(STEntityDescriptor *)edesc
                           inRect:(NSRect)drawRect
                            level:(int)level
                           offset:(float)offset;
- (void)drawInstance:(id)instance
              ofTree:(MiscTree *)tree
              inRect:(NSRect)drawRect
               level:(int)level
              offset:(float)offset;
- (void)drawContainer:(PajeContainer *)container
               ofTree:(MiscTree *)tree
               inRect:(NSRect)drawRect
                level:(int)level
               offset:(float)offset;
@end
#endif
