/* PieCell.h created by benhur on Wed 24-Sep-1997 */
/*
   Cell that shows a pie-chart.
   The values of the pie are in "representedObject", that is an NSArray
   of NSDictionaries, each with a "Value", "Color", and "Name" fields.
   */
#import <AppKit/AppKit.h>
#import "StatArray.h"
#import "StatValue.h"

@interface PieCell : NSCell
{
    id dataProvider;
    StatArray *data;
    NSNumber *initialAngle;
    BOOL simple;              // true if undecorated display
    int type;
    BOOL showPercent;
}

- (void)setDataProvider:(id)provider;
- (void)setData:(StatArray *)d;

// overrides from NSCell:
- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView;
- (void)setInitialAngle:(NSNumber *)angle;
- (void)setGraphType:(int)t;
- (void)setShowPercent:(BOOL)yn;
@end
