#ifndef _StatViewer_h_
#define _StatViewer_h_

#import <AppKit/AppKit.h>
#import "PieCell.h"
#import "StatArray.h"
#import "StatValue.h"
#import "../General.bproj/PajeFilter.h"

@interface StatViewer: PajeFilter
{
    id matrix;
    id window;
    PajeFilter *filter;
    NSDate *startTime;
    NSDate *endTime;
    id graphSelector;
    id graphTypeSelector;
    id percentSelector;
    id durationField;
}
- (void)awakeFromNib;

- (void)setStartTime:(NSDate *)time;
- (void)setEndTime:(NSDate *)time;

- (void)timeSelectionChanged:(NSNotification *)notification;
- (void)changeInitialAngle:(id)sender;
- (void)changeGraph:(id)sender;
- (void)changeData:(id)sender;

- (void)invalidateValues;
- (void)provideDataForCell:(PieCell *)cell;

- (void)windowDidResize:(NSNotification *)notification;
- (void)print:(id)sender;
@end

#endif
